from elastic_paribhasha.base_elastic_index import BaseIndex


class CostMetricsIndex(BaseIndex):
    def __init__(self, elastic_url=None, index_region=None):
        self.index_name = 'cost-metrics'
        self.search_endpoint = '/_search'
        self.elastic_url = elastic_url
        self.region = index_region
        super().__init__()

    def query(self, query, org_id):

        elastic_query = {}

        if query.get('version'):
            elastic_query['version'] = query.get('version')

        if query.get('size'):
            elastic_query['size'] = query.get('size')
        else:
            elastic_query['size'] = 500

        if query.get('sort'):
            elastic_query['sort'] = query.get('sort')

        if query.get('aggs'):
            elastic_query['aggs'] = query.get('aggs')

        if query.get('stored_fields'):
            elastic_query['stored_fields'] = query.get('stored_fields')

        if query.get('script_fields'):
            elastic_query['script_fields'] = query.get('script_fields')
        else:
            elastic_query['script_fields'] = {}

        if query.get('docvalue_fields'):
            elastic_query['docvalue_fields'] = query.get('docvalue_fields')

        if query.get('_source') and query.get('_source').get('excludes'):
            elastic_query['_source'] = {
                'excludes': query.get('_source').get('excludes')
            }

        elastic_query['query'] = {
            'bool': {
                'must': [query.get('query')],
                'filter': [{
                    "match": {
                        "organization.org_id": org_id
                    }
                }]
            }
        }

        if query.get('highlight'):
            elastic_query['highlight'] = query.get('highlight')

        print("querying:..", elastic_query, flush=True)
        print('results::::', self.run_query(elastic_query))
